package com.huimv.farm.damsubsidy.controller;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillIsolated;
import com.huimv.farm.damsubsidy.entity.vo.BillIsolatedVo;
import com.huimv.farm.damsubsidy.service.IBillIsolatedService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 落地检 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-isolated")
@CrossOrigin
public class BillIsolatedController {

    @Autowired
    private IBillIsolatedService iBillIsolatedService;

    @PostMapping("/addIsolation")
    public Result  addIsolation(HttpServletRequest httpServletRequest,
                                @RequestParam("observeImage") MultipartFile observeImage,
                                @RequestParam("inspectionNum") String inspectionNum,
                                @RequestParam("isolatedPosition") String isolatedPosition,
                                @RequestParam("strIsolated") String strIsolated,
                                @RequestParam("dayIsolated") String dayIsolated) throws ParseException, IOException {
        return iBillIsolatedService.addIsolation(httpServletRequest,observeImage,inspectionNum,isolatedPosition,strIsolated,dayIsolated);
    }

    @PostMapping("/listIsolation")
    public Result listIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillIsolatedService.listIsolation(httpServletRequest,paramsMap);
    }

    @PostMapping("/delayedIsolation")
    public Result delayedIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillIsolatedService.delayedIsolation(httpServletRequest,paramsMap);
    }

    @PostMapping("/cancelIsolation")
    public Result cancelIsolation(HttpServletRequest httpServletRequest,
                                  @RequestParam(value = "isolatedImage1",required = false) MultipartFile isolatedImage1,
                                  @RequestParam(value = "isolatedImage2",required = false) MultipartFile isolatedImage2,
                                  @RequestParam(value = "isolatedImage3",required = false) MultipartFile isolatedImage3,
                                  @RequestParam("observeSecureImage") MultipartFile observeSecureImage,
                                  @RequestParam("id") String id,
                                  @RequestParam("isDead") String isDead,
                                  @RequestParam("deaths") String deaths) throws IOException {
        return iBillIsolatedService.cancelIsolation(httpServletRequest,isolatedImage1,isolatedImage2,isolatedImage3,observeSecureImage,id,isDead,deaths);
    }

    @PostMapping("/listDetail")
    public Result listDetail(@RequestBody Map<String, String> paramsMap){
        String inspectionNum = paramsMap.get("inspectionNum");
        BillIsolated inspection = iBillIsolatedService.getOne(new QueryWrapper<BillIsolated>().eq("inspection_num", inspectionNum));
        BillIsolatedVo billIsolatedVo = new BillIsolatedVo();
        if (ObjectUtil.isNotEmpty(inspection)) {
            BeanUtil.copyProperties(inspection,billIsolatedVo);
            if (ObjectUtil.isNotEmpty(inspection.getIsolatedPicUrl())){
                billIsolatedVo.setPages(inspection.getIsolatedPicUrl().split(","));
            }
        }
        return new Result(ResultCode.SUCCESS, billIsolatedVo);
    }

    @PostMapping("/listPcIsolation")
    public Result listPcIsolation(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap){
        return iBillIsolatedService.listPcIsolation(httpServletRequest,paramsMap);
    }
}
