package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.ExcelWriter;
import cn.hutool.poi.excel.StyleSet;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.api.R;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.BankUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.entity.*;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.vo.BillSubsidyDto;
import com.huimv.farm.damsubsidy.entity.vo.BillSubsidyReportVo;
import com.huimv.farm.damsubsidy.mapper.*;
import com.huimv.farm.damsubsidy.service.IBillSubsidyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.farm.test.Print2;
import com.huimv.farm.test.Print3;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import javax.annotation.Resource;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 补贴信息表 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BillSubsidyServiceImpl extends ServiceImpl<BillSubsidyMapper, BillSubsidy> implements IBillSubsidyService {

    @Autowired
    private BillSubsidyMapper subsidyMapper;
    @Autowired
    private SysUserMapper sysUserMapper;
    @Autowired
    private BaseAnimalMapper animalMapper;
    @Autowired
    private AreaAllMapper areaAllMapper;
    @Resource
    private BillSubsidyModifyMapper billSubsidyModifyMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String type = paramsMap.get("subsidySch");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }

        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.like("brief_address_code", TokenSign.getAddressCode(httpServletRequest));
        if (type == null || type == "") {
            queryWrapper.orderByDesc("create_time");
        } else if (Integer.parseInt(type) == 1) {
            queryWrapper.eq("subsidy_sch", 0).orderByDesc("create_time");
        } else if (Integer.parseInt(type) == 2) {
            queryWrapper.in("subsidy_sch", 1, 5).orderByDesc("create_time");
        } else {
            queryWrapper.in("subsidy_sch", 2, 3).orderByDesc("create_time");
        }
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
//        List<BillSubsidy> billSubsidies = subsidyMapper.selectList(queryWrapper);

//        JSONArray jsonArray = new JSONArray();
//        for (BillSubsidy billSubsidy : billSubsidies) {
//            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("name", billSubsidy.getSubsidyName());
//            jsonObject.put("date", billSubsidy.getSubTime());
//            jsonObject.put("state", billSubsidy.getSubsidySch());
//            jsonObject.put("id", billSubsidy.getId());
//            jsonArray.add(jsonObject);
//        }
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result listById(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", paramsMap.get("id"));
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        return new Result(ResultCode.SUCCESS, billSubsidy);
    }

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Result edit(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer type = Integer.parseInt(paramsMap.get("type"));
        String id = paramsMap.get("id");
        //拒绝
        if (type == 1) {
            String refuseReason = paramsMap.get("refuseReason"); //拒绝理由
            if (refuseReason == "" || refuseReason == null) {
                return new Result(10001, "拒绝理由不能为空！", false);
            }
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            String inspectionNum = billSubsidy.getInspectionNum();
            QueryWrapper<BaseAnimal> animalQueryWrapper = new QueryWrapper<>();
            animalQueryWrapper.eq("inspection_num", inspectionNum);
            List<BaseAnimal> baseAnimals = animalMapper.selectList(animalQueryWrapper);
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setIsLoated(0);
                if (animalMapper.updateById(baseAnimal) != 1) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return new Result(10001, "操作失败", false);
                }
            }
            billSubsidy.setRefuseReason(refuseReason);
            billSubsidy.setSubsidySch(2);
            billSubsidy.setReviewedDepart(TokenSign.getUserName(httpServletRequest));
            billSubsidy.setAcceptTime(new Date());
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        } else { //受理
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            billSubsidy.setSubsidySch(1);
            billSubsidy.setAcceptTime(new Date());
            billSubsidy.setReviewedDepart(TokenSign.getUserName(httpServletRequest));
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        }
    }

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Result edit2(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer type = Integer.parseInt(paramsMap.get("type"));
        String id = paramsMap.get("id");

        String workAccptUrl = paramsMap.get("workAccptUrl");
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        if (type == 1) { //驳回
            String rejectReason = paramsMap.get("rejectReason");
            if (rejectReason == null || "".equals(rejectReason)) {
                return new Result(10001, "驳回理由不能为空！", false);
            }
            if (workAccptUrl == null || "".equals(workAccptUrl)) {
                return new Result(10001, "工作验收表不能为空！", false);
            }
            billSubsidy.setSubsidySch(4);
            billSubsidy.setRejectReason(rejectReason);
            billSubsidy.setWorkAccptUrl(workAccptUrl);
            billSubsidy.setAcceptTime(new Date());
            billSubsidy.setReviewedDepart(TokenSign.getUserName(httpServletRequest));
            QueryWrapper<BaseAnimal> animalQueryWrapper = new QueryWrapper<>();
            animalQueryWrapper.eq("inspection_num", billSubsidy.getInspectionNum());
            List<BaseAnimal> baseAnimals = animalMapper.selectList(animalQueryWrapper);
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setIsLoated(0);
                baseAnimal.setAnimalStatus(1);
                if (animalMapper.updateById(baseAnimal) != 1) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return new Result(10001, "操作失败", false);
                }
            }
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        } else { //通过
            billSubsidy.setSubsidySch(3);
            billSubsidy.setAcceptTime(new Date());
            if (workAccptUrl == null || workAccptUrl == "") {
                billSubsidy.setIsPay(0);
            } else {
                billSubsidy.setWorkAccptUrl(workAccptUrl);
                billSubsidy.setIsPay(1);
            }
            billSubsidy.setReviewedTime(new Date());
            billSubsidy.setReviewedDepart(TokenSign.getUserName(httpServletRequest));
            subsidyMapper.updateById(billSubsidy);
            return new Result(ResultCode.SUCCESS, billSubsidy);
        }
    }

    @Override
    public Result appeal(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        Integer type = Integer.parseInt(paramsMap.get("type"));
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        if (type == 1) { //驳回
            billSubsidy.setSubsidySch(4);
            billSubsidy.setAppealTime(new Date());
            subsidyMapper.updateById(billSubsidy);
        } else {
            billSubsidy.setSubsidySch(3);
            billSubsidy.setAppealTime(new Date());
            subsidyMapper.updateById(billSubsidy);
        }
        return new Result(ResultCode.SUCCESS, billSubsidy);
    }

    @Resource
    private BaseAnimalMapper baseAnimalMapper;
    @Resource
    private BaseUserBankMapper baseUserBankMapper;
    @Resource
    private BillLandingInspectionMapper billLandingInspectionMapper;
    @Resource
    private BillBuyInfoMapper billBuyInfoMapper;

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Result addApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        Integer type = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("id", TokenSign.getMemberIdByJwtToken(httpServletRequest))).getUserType();
        Long id = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        SysUser sysUser = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("id", id));

        if (type == 2) {
            if ("".equals(billSubsidy.getFarmName())) {
                return new Result(10001, "牧场名称不能为空", false);
            }
            if ("".equals(billSubsidy.getNameTwo())) {
                return new Result(10001, "负责人不能为空", false);
            }
            if (StringUtils.isBlank(sysUser.getCompanyName())){
                return new Result(10001, "账号无法人信息,请联系管理员!", false);
            }
            billSubsidy.setCompanyName(sysUser.getCompanyName());
            billSubsidy.setSubsidyType(1);
        }
        if (type == 3) {
            if ("".equals(billSubsidy.getFarmerName())) {
                return new Result(10001, "农户姓名不能为空", false);
            }
            if ("".equals(billSubsidy.getFarmerType())) {
                return new Result(10001, "农户类型不能为空", false);
            }
            billSubsidy.setSubsidyType(0);
        }
        String eartagNo = billSubsidy.getEartagNo();
        String[] eartags = eartagNo.split(",");
        if (eartags.length != billSubsidy.getRewardNum()) {
            return new Result(10001, "奖补数应与实际耳标号数量相同", false);
        }

        if (billSubsidy.getExistNum() < billSubsidy.getImportNum()) {
            return new Result(10001, "引进数应小于或等于存栏数!", false);
        }
        if (billSubsidy.getImportNum() < billSubsidy.getRewardNum()) {
            return new Result(10001, "奖补数应小于或等于引进数!", false);
        }
        BaseUserBank bankCard = baseUserBankMapper.selectOne(new QueryWrapper<BaseUserBank>().eq("bank_id", billSubsidy.getBankCardId()));
        billSubsidy.setBankName(bankCard.getBankName());
        billSubsidy.setBankImgUrl(bankCard.getBankImgUrl());
        billSubsidy.setBankBelongTo(bankCard.getBankBelongTo());
        billSubsidy.setBankReservePhone(bankCard.getBankReservePhone());
//        if (!(BankUtil.checkBankCard(bankCardId))) {
//            return new Result(10001, "银行卡号不符合标准!", false);
//        }
//        if (ObjectUtil.isEmpty(BankUtil.getname(bankCardId))) {
//            return new Result(10001, "补贴账号有误,请检查!", false);
//        }
        for (String eartag : eartags) {
            if (!eartag.contains("-")) {
                BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", eartag));
                animal.setIsLoated(1);
                if (baseAnimalMapper.updateById(animal) != 1) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return new Result(10001, "操作失败", false);
                }
            } else {
                String start = eartag.substring(0, eartag.indexOf("-"));
                String end = eartag.substring(eartag.indexOf("-") + 1);
                String substring = start.substring(0, start.length() - end.length());
                String finish = substring + end;
                List<Integer> numbers = new ArrayList<>();
                for (int i = Integer.parseInt(start); i <= Integer.parseInt(finish); i++) {
                    numbers.add(i);
                }
                for (Integer number : numbers) {
                    String earatgNo = number.toString();
                    BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", earatgNo));
                    animal.setIsLoated(1);
                    if (baseAnimalMapper.updateById(animal) != 1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return new Result(10001, "操作失败", false);
                    }
                }
            }
        }
        billSubsidy.setSubsidyName(TokenSign.getUserName(httpServletRequest) + "的补贴申请");
        billSubsidy.setDetailedAdress(sysUser.getDetailedAdress());
        billSubsidy.setDetailedAdressCode(sysUser.getDetailedAdressCode());
        billSubsidy.setBriefAddress(sysUser.getBriefAddress());
        billSubsidy.setBriefAddressCode(sysUser.getBriefAddressCode());
        billSubsidy.setCreateTime(DateTime.now());
        billSubsidy.setCreateUser(id);
        Integer count = billBuyInfoMapper.selectCount(new QueryWrapper<BillBuyInfo>().eq("inspection_num", billSubsidy.getInspectionNum()));

        String[] split = billSubsidy.getInspectionNum().split(",");
        BillLandingInspection billLandingInspection = billLandingInspectionMapper.selectOne(new QueryWrapper<BillLandingInspection>()
                .eq("inspection_num", split[0])
//                .ne("inspection_type",0)
                .eq("inspection_sch", 4));
        Integer userType = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("id", billLandingInspection.getCreateUser())).getUserType();

        if (count != 0 && userType == 2) {
            billSubsidy.setSaleName(billLandingInspection.getCargoOwner());
        }
        billSubsidy.setSubsidySch(0);
        Long userName = id;
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(subsidy)) {
            this.save(billSubsidy);
        } else {
            this.update(billSubsidy, new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result saveApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        Long userName = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        BaseUserBank bankCard = baseUserBankMapper.selectOne(new QueryWrapper<BaseUserBank>().eq("bank_id", billSubsidy.getBankCardId()));
        billSubsidy.setBankName(bankCard.getBankName());
        billSubsidy.setBankImgUrl(bankCard.getBankImgUrl());
        billSubsidy.setBankBelongTo(bankCard.getBankBelongTo());
        billSubsidy.setBankReservePhone(bankCard.getBankReservePhone());
        billSubsidy.setSubsidySch(7);
        billSubsidy.setCreateUser(userName);
        if (ObjectUtil.isEmpty(subsidy)) {
            this.save(billSubsidy);
        } else {
            this.update(billSubsidy, new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result listPcSub(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer userType = TokenSign.getUserType(httpServletRequest);
        String userName = paramsMap.get("userName");
        String date = paramsMap.get("date");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        String type = paramsMap.get("type");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }
        if (userType == 0) {
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.between(StringUtils.isNotBlank(date), "create_time", date + " 00:00:00", date + " 23:59:59")
                    .like(StringUtils.isNotBlank(userName), "farmer_name", userName);

            if (Integer.parseInt(type) == 7) {
                queryWrapper.eq("is_pay", 1).orderByDesc("create_time");
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            if (Integer.parseInt(type) == 6) {
                queryWrapper.eq("is_pay", 2).orderByDesc("create_time");
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            if (Integer.parseInt(type) == 3) {
                queryWrapper.in("is_pay", 0, 1).eq("subsidy_sch", 3).orderByDesc("create_time");
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            queryWrapper.eq(StringUtils.isNotBlank(type), "subsidy_sch", type).orderByDesc("create_time");
            Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
            return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
        } else {
            String addressCode = TokenSign.getAddressCode(httpServletRequest);
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.between(StringUtils.isNotBlank(date), "create_time", date + " 00:00:00", date + " 23:59:59")
                    .like(StringUtils.isNotBlank(userName), "farmer_name", userName).like("brief_address_code", addressCode);

            if (Integer.parseInt(type) == 7) {
                queryWrapper.eq("is_pay", 1).orderByDesc("create_time").like("brief_address_code", addressCode);
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            if (Integer.parseInt(type) == 6) {
                queryWrapper.eq("is_pay", 2).orderByDesc("create_time").like("brief_address_code", addressCode);
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            if (Integer.parseInt(type) == 3) {
                queryWrapper.in("is_pay", 0, 1).eq("subsidy_sch", 3).orderByDesc("create_time").like("brief_address_code", addressCode);
                Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
                return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
            }
            queryWrapper.eq(StringUtils.isNotBlank(type), "subsidy_sch", type).orderByDesc("create_time").like("brief_address_code", addressCode);
            Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
            return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
        }

    }

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Result editApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        String type = paramsMap.get("type");
        BillSubsidy billSubsidy = this.getById(id);
        //养殖户撤销补贴申请
//        if ("1".equals(type)){
//            billSubsidy.setSubsidySch(8);
//            billSubsidy.setRevokeTime(LocalDate.now());
//            this.updateById(billSubsidy);
//            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().eq("inspection_num", billSubsidy.getInspectionNum()));
//            for (BaseAnimal baseAnimal : baseAnimals) {
//                baseAnimal.setIsLoated(0);
//                baseAnimalMapper.updateById(baseAnimal);
//            }
//            return Result.SUCCESS();
//        }
        if ("1".equals(type)) {
            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>()
                    .eq("inspection_num", billSubsidy.getInspectionNum())
                    .eq("belong_to_user", TokenSign.getMemberIdByJwtToken(httpServletRequest)));
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setIsLoated(0);
                if (baseAnimalMapper.updateById(baseAnimal) != 1) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return new Result(10001, "操作失败", false);
                }
            }
            this.removeById(billSubsidy);
            return Result.SUCCESS();
        } else {
//          养殖户申诉不通过补贴申请
            String appeal = paramsMap.get("appeal");
            billSubsidy.setAppeal(appeal);
            billSubsidy.setSubsidySch(5);
            billSubsidy.setIsShensu(1);
            billSubsidy.setAppealTime(new Date());
            if (this.updateById(billSubsidy)) {
                return Result.SUCCESS();
            } else {
                return Result.ERROR();
            }
        }
    }

    @Override
    public Result listApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String subsidySch = paramsMap.get("subsidySch");
//        String startTime = paramsMap.get("startTime");
//        String endTime = paramsMap.get("endTime");
        Long userName = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        Integer userType = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("id", userName)).getUserType();

        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();

        if (userType == 2 || userType == 3) {
            subsidyQueryWrapper.eq("create_user", userName);
            if (ObjectUtil.isNotEmpty(subsidySch)) {
                if (subsidySch.equals("1")) {
                    subsidyQueryWrapper.eq("subsidy_sch", 0);
                } else if (subsidySch.equals("2")) {
                    subsidyQueryWrapper.in("subsidy_sch", 1, 5);
                } else if (subsidySch.equals("3")) {
                    subsidyQueryWrapper.in("subsidy_sch", 2, 3, 4);
                } else if (subsidySch.equals("4")) {
                    subsidyQueryWrapper.eq("is_pay", 2);
                }
            } else {
                subsidyQueryWrapper.ne("subsidy_sch", 7);
            }
        } else {
            if (ObjectUtil.isNotEmpty(subsidySch)) {
                if (subsidySch.equals("1")) {
                    subsidyQueryWrapper.eq("subsidy_sch", 0);
                } else if (subsidySch.equals("2")) {
                    subsidyQueryWrapper.in("subsidy_sch", 1, 5);
                } else if (subsidySch.equals("3")) {
                    subsidyQueryWrapper.in("subsidy_sch", 2, 3, 4);
                } else if (subsidySch.equals("4")) {
                    subsidyQueryWrapper.eq("is_pay", 2);
                }
            } else {
                subsidyQueryWrapper.ne("subsidy_sch", 7);
            }
        }
//        if (startTime != null) {
//            startTime = startTime + " 00:00:00";
//            subsidyQueryWrapper.ge("create_time",startTime);
//        }
//        if (endTime != null) {
//            endTime = endTime + " 23:59:59";
//            subsidyQueryWrapper.le("create_time",endTime);
//        }

        subsidyQueryWrapper.orderByDesc("create_time");
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, subsidyQueryWrapper));
    }

    @Override
    public Result getLast(HttpServletRequest httpServletRequest, Map<String, String> parasMap) {
        BillSubsidy billSubsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", TokenSign.getMemberIdByJwtToken(httpServletRequest)).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(billSubsidy)) {
            return new Result(ResultCode.SUCCESS, null);
        } else {
            return new Result(ResultCode.SUCCESS, billSubsidy);
        }
    }

    @Override
    public Result listFlow(Map<String, String> parasMap) {
        String id = parasMap.get("id");
        BillSubsidy billSubsidy = this.getById(id);
        List result = new ArrayList();
        if (billSubsidy.getSubsidySch() == 0) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setStatus(true);
            addApplication.setReason("");
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication lastApplication = new RejectApplication();
            lastApplication.setStatus(true);
            lastApplication.setTitle("待受理");
            result.add(lastApplication);
        } else if (billSubsidy.getSubsidySch() == 1) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setStatus(true);
            addApplication.setReason("");
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setStatus(true);
            receiveApplication.setReason("");
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            RejectApplication lastApplication = new RejectApplication();
            lastApplication.setStatus(true);
            lastApplication.setTitle("审核中");
            result.add(lastApplication);
        } else if (billSubsidy.getSubsidySch() == 2) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);
            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("已拒绝");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getAcceptTime());
            rejectApplication.setReason("拒绝理由:" + billSubsidy.getRefuseReason());
            result.add(rejectApplication);
            if (billSubsidy.getAppeal() != null) {
                RejectApplication shensuApplication = new RejectApplication();
                shensuApplication.setTitle("已申诉");
                shensuApplication.setStatus(true);
                shensuApplication.setTime(billSubsidy.getAcceptTime());
                shensuApplication.setReason("");
                result.add(shensuApplication);
            }
        } else if (billSubsidy.getSubsidySch() == 3) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setReason("");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);

            if (billSubsidy.getAppeal() != null) {
                RejectApplication shensuApplication = new RejectApplication();
                shensuApplication.setTitle("已申诉");
                shensuApplication.setStatus(true);
                shensuApplication.setTime(billSubsidy.getAcceptTime());
                shensuApplication.setReason("");
                result.add(shensuApplication);
            }

            RejectApplication acceptApplication = new RejectApplication();
            acceptApplication.setTitle("审核通过");
            acceptApplication.setReason("");
            acceptApplication.setStatus(true);
            acceptApplication.setTime(billSubsidy.getAcceptTime());
            result.add(acceptApplication);

            if (billSubsidy.getIsPay() == 2) {
                RejectApplication payApplication = new RejectApplication();
                payApplication.setTitle("已支付");
                payApplication.setStatus(true);
                payApplication.setTime(billSubsidy.getPayTime());
                if (ObjectUtil.isEmpty(billSubsidy.getPayMoney())) {
                    payApplication.setReason("支付金额: ¥" + "");
                } else {
                    payApplication.setReason("支付金额: ¥" + billSubsidy.getPayMoney().toString());
                }
                result.add(payApplication);
            } else {
                RejectApplication lastApplication = new RejectApplication();
                lastApplication.setTitle("待支付");
                lastApplication.setReason("");
                lastApplication.setStatus(true);
                result.add(lastApplication);
            }
        } else if (billSubsidy.getSubsidySch() == 4) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setTitle("已受理");
            receiveApplication.setReason("");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);
            if (billSubsidy.getIsShensu() == 1) {
                RejectApplication shensuApplication = new RejectApplication();
                shensuApplication.setTitle("已驳回");
                shensuApplication.setStatus(true);
                shensuApplication.setTime(billSubsidy.getAcceptTime());
                shensuApplication.setReason("");
                result.add(shensuApplication);

                RejectApplication shensuApplication2 = new RejectApplication();
                shensuApplication2.setTitle("已申诉");
                shensuApplication2.setStatus(true);
                shensuApplication2.setTime(billSubsidy.getAcceptTime());
                shensuApplication2.setReason("");
                result.add(shensuApplication2);

            }
            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("审核不通过");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getReviewedTime());
            rejectApplication.setReason("驳回理由: " + billSubsidy.getRejectReason());
            result.add(rejectApplication);

        } else if (billSubsidy.getSubsidySch() == 5) {
            RejectApplication addApplication = new RejectApplication();
            addApplication.setTitle("提交申请");
            addApplication.setReason("");
            addApplication.setStatus(true);
            addApplication.setTime(billSubsidy.getCreateTime());
            result.add(addApplication);

            RejectApplication receiveApplication = new RejectApplication();
            receiveApplication.setReason("");
            receiveApplication.setTitle("已受理");
            receiveApplication.setStatus(true);
            receiveApplication.setTime(billSubsidy.getAcceptTime());
            result.add(receiveApplication);


            RejectApplication rejectApplication = new RejectApplication();
            rejectApplication.setTitle("审核不通过");
            rejectApplication.setStatus(false);
            rejectApplication.setTime(billSubsidy.getReviewedTime());
            rejectApplication.setReason("驳回理由: " + billSubsidy.getRejectReason());
            result.add(rejectApplication);

            RejectApplication appealApplication = new RejectApplication();
            appealApplication.setTitle("已申诉");
            appealApplication.setStatus(true);
            appealApplication.setTime(billSubsidy.getAppealTime());
            appealApplication.setReason("申诉内容描述: " + billSubsidy.getAppeal());
            result.add(appealApplication);

            RejectApplication lastApplication = new RejectApplication();
            lastApplication.setTitle("待受理");
            lastApplication.setStatus(true);
            lastApplication.setReason("");
            result.add(lastApplication);
        }
        return new Result(ResultCode.SUCCESS, result);
    }

    //打印待支付的
    @Override
    public Result printPay(HttpServletResponse response, Map<String, String> paramsMap) throws IOException {
        String ids = paramsMap.get("ids");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate");
        String address = paramsMap.get("address");

        QueryWrapper<BillSubsidy> wrapper = new QueryWrapper<>();
        if (StringUtils.isBlank(startDate)) {
            Date date = new Date();
            startDate = DateUtil.format(date, "yyyy-MM-dd");
            wrapper.ge("create_time", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            String endTime = endDate + " 23:59:59";
            wrapper.le("create_time", endTime);
        }


        if (StringUtils.isNotBlank(ids)) {
            List<String> list = Arrays.asList(ids.split(","));
            wrapper.in("id", list);
        }
        wrapper.eq("is_pay", 1);
        wrapper.eq("subsidy_sch", 3);
        List<BillSubsidy> billSubsidies = subsidyMapper.selectList(wrapper);
        if (ObjectUtil.isEmpty(billSubsidies)) {
            return new Result(10001, "当前无待支付名单", true);
        }
        ExcelWriter writer = ExcelUtil.getWriter();
        ServletOutputStream outputStream = null;
        try {
            outputStream = response.getOutputStream();

            writer.merge(5, startDate + "-" + endDate + "  待支付名单");
            writer.write(billSubsidies, true);
            writer.addHeaderAlias("farmerName", "姓名");
            writer.addHeaderAlias("bankCardId", "卡号");
            writer.addHeaderAlias("idCard", "身份证");
            writer.addHeaderAlias("bankName", "开户行");
            writer.addHeaderAlias("phone", "手机号");
            writer.addHeaderAlias("createTime", "提交时间");
            writer.addHeaderAlias("applyMoney", "申报金额");

            writer.flush(outputStream);

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            writer.close();
            outputStream.close();
        }
        return null;
    }

    @Override
    public void printPay2(HttpServletResponse response, String startDate, String endDate) throws IOException {

        QueryWrapper<BillSubsidy> wrapper = new QueryWrapper<>();
     /*   if (StringUtils.isBlank(startDate)) {
            Date date = new Date();
            startDate = DateUtil.format(date, "yyyy-MM-dd");
            wrapper.ge("create_time", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            String endTime = endDate + " 23:59:59";
            wrapper.le("create_time", endTime);
        }*/
        if (StringUtils.isBlank(startDate) || StringUtils.isBlank(endDate)) {
            Date date = new Date();
            endDate = DateUtil.format(date, "yyyy-MM-dd");
            String endTime = endDate + " 23:59:59";
            wrapper.le("create_time", endTime);
        } else {
            startDate = startDate + " 00:00:00";
            endDate = endDate + " 23:59:59";
            wrapper.between("create_time", startDate, endDate);
        }
        wrapper.eq("is_pay", 1);
        wrapper.eq("subsidy_sch", 3);
        List<BillSubsidy> billSubsidies = subsidyMapper.selectList(wrapper);
        List list = new ArrayList();
        for (BillSubsidy billSubsidy : billSubsidies) {
            Map<String, Object> map = new HashMap();
            map.put("姓名", billSubsidy.getFarmerName());
            map.put("卡号", billSubsidy.getBankCardId());
            map.put("身份证", billSubsidy.getIdCard());
            map.put("开户行", billSubsidy.getBankName());
            map.put("手机号", billSubsidy.getPhone());
            map.put("提交时间", billSubsidy.getCreateTime());
            map.put("申报金额", billSubsidy.getApplyMoney());
            list.add(map);
        }

        ExcelWriter writer = ExcelUtil.getWriter();
        ServletOutputStream outputStream = null;
        try {
            outputStream = response.getOutputStream();
            StringBuffer fileName = new StringBuffer();
            if (StringUtils.isNotBlank(endDate)) {
                fileName.append(startDate);
                fileName.append(" 至 ");
                fileName.append(endDate);
                fileName.append("   待支付名单");
            } else {
                fileName.append("至今所有待支付名单");
            }
            writer.merge(6, fileName.toString());

            System.out.println(fileName);
            fileName.append(".xls");
            response.setHeader("content-disposition", "attachment;fileName=" + URLEncoder.encode(fileName.toString(), "UTF-8"));

            writer.write(list, true);
            writer.setRowHeight(0, 25);
            writer.setRowHeight(1, 15);
            writer.setColumnWidth(0, 10);
            writer.setColumnWidth(1, 20);
            writer.setColumnWidth(2, 20);
            writer.setColumnWidth(3, 25);
            writer.setColumnWidth(4, 25);
            writer.setColumnWidth(5, 30);
            writer.setColumnWidth(6, 30);

            writer.flush(outputStream);

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            writer.close();
            outputStream.close();
        }
    }

    @Override
    public void printAmount(HttpServletResponse httpServletResponse, Map<String, String> paramsMap) {
        String code = paramsMap.get("code");
        String start = paramsMap.get("start");
        String end = paramsMap.get("end");
        if ("1".equals(code)) {
            List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.lisTowntReport("621121", start, end);
            try {
                Print2.print2(billSubsidyReportVos, "通渭县", end);
            } catch (Exception e) {
                System.out.println("打印县阶段统计表出异常！！！");
                e.printStackTrace();
            }
        } else {
            QueryWrapper<AreaAll> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", code);
            AreaAll areaAll = areaAllMapper.selectOne(queryWrapper);//得到乡镇地址
            List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.listReport(code, start, end);
            try {
                Print2.print(billSubsidyReportVos, areaAll.getName(), end);
            } catch (Exception e) {
                System.out.println("打印镇阶段统计表出异常！！！");
                e.printStackTrace();
            }
        }

    }

    @Override
    public void printWaitPay(HttpServletResponse httpServletResponse, Map<String, String> paramsMap) {
        String code = paramsMap.get("code");
        String start = paramsMap.get("start");
        String end = paramsMap.get("end");
        Date date = new Date();
        String format = DateUtil.format(date, "yyyy-MM-dd");
        if (StringUtils.isBlank(start)) {
            start = format + " 00:00:00";
        } else {
            start = start + " 00:00:00";
        }
        if (StringUtils.isBlank(end)) {
            end = format + " 23:59:59";
        } else {
            end = end + " 23:59:59";
        }
        QueryWrapper<AreaAll> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", code);
        AreaAll all = areaAllMapper.selectOne(queryWrapper);
        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();

        subsidyQueryWrapper.like(StringUtils.isNotBlank(code), "detailed_adress_code", code)
                .between("create_time", start, end).eq("subsidy_sch", 3).eq("is_pay", 1)
                .groupBy("id_card");
        List<BillSubsidy> subsidyList = subsidyMapper.selectList(subsidyQueryWrapper);
        try {
            Print3.print(subsidyList, all.getName(), end);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public Result countState(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String code = paramsMap.get("country");
        String start = paramsMap.get("startDate");
        String end = paramsMap.get("endDate");
        Integer userType = TokenSign.getUserType(httpServletRequest);
        if (userType == 0) {
            if (code == null || "".equals(code)) {
                code = "621121";
                List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.lisTowntReport(code, start, end);//县
                return new Result(ResultCode.SUCCESS, billSubsidyReportVos);
            } else {
                List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.listReport(code, start, end);//镇
                return new Result(ResultCode.SUCCESS, billSubsidyReportVos);
            }
        }
        if (userType == 4) {
            code = TokenSign.getAddressCode(httpServletRequest);
            List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.listReport(code, start, end);//镇
            return new Result(ResultCode.SUCCESS, billSubsidyReportVos);
        }
        List<BillSubsidyReportVo> billSubsidyReportVos = subsidyMapper.listReport(code, start, end);
        return new Result(ResultCode.SUCCESS, billSubsidyReportVos);
    }

    @Override
    public Result countPay(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String code = paramsMap.get("country");
        if (code == null || "".equals(code)) {
            code = TokenSign.getAddressCode(httpServletRequest);//镇的编码
        }
        String start = paramsMap.get("startDate");
        String end = paramsMap.get("endDate");
        Date date = new Date();
        String format = DateUtil.format(date, "yyyy-MM-dd");
        if (StringUtils.isBlank(start)) {
            start = format + " 00:00:00";
        } else {
            start = start + " 00:00:00";
        }
        if (StringUtils.isBlank(end)) {
            end = format + " 23:59:59";
        } else {
            end = end + " 23:59:59";
        }

        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();
        subsidyQueryWrapper.like(StringUtils.isNotBlank(code), "detailed_adress_code", code)
                .between("create_time", start, end).eq("subsidy_sch", 3).eq("is_pay", 1)
                .groupBy("id_card");
        List<BillSubsidy> subsidyList = subsidyMapper.selectList(subsidyQueryWrapper);
        return new Result(ResultCode.SUCCESS, subsidyList);
    }

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Result editSubsidy(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        String afterRewardNum = paramsMap.get("afterRewardNum");
        String afterEartagNo = paramsMap.get("afterEartagNo");
        String afterApplyMoney = paramsMap.get("afterApplyMoney");

        BillSubsidy billSubsidy = subsidyMapper.selectById(id);
        String[] beforeSplit = billSubsidy.getEartagNo().split(",");
        String[] afterSplit = afterEartagNo.split(",");
        if (afterSplit.length != Integer.parseInt(afterRewardNum)) {
            return new Result(10001, "奖补数量与实际耳标号数量不符", false);
        }
        List<String> afterList = Arrays.asList(afterSplit);
        List<String> beforeList = Arrays.asList(beforeSplit);

        List<String> result = new ArrayList<>(beforeList);
        result.removeAll(afterList);
        ArrayList<String> eartags = new ArrayList<>();
        for (String s : result) {
            eartags.add(s);
        }
        if (ObjectUtil.isNotEmpty(eartags)){
            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().in("earatg_no", eartags));
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setAnimalStatus(4);
                if (baseAnimalMapper.updateById(baseAnimal) != 1) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return new Result(10001, "耳标号" + baseAnimal.getEaratgNo() + "修改失败", false);
                }
            }
        }
        BillSubsidyModify billSubsidyModify = new BillSubsidyModify();
        billSubsidyModify.setSubsidyId(id);
        billSubsidyModify.setUpdateUserId(TokenSign.getMemberIdByJwtToken(httpServletRequest));
        billSubsidyModify.setUpdateTime(new Date());
        billSubsidyModify.setUpdateUserName(sysUserMapper.selectById(TokenSign.getMemberIdByJwtToken(httpServletRequest)).getUserName());
        billSubsidyModify.setBeforeApplyMoney(billSubsidy.getApplyMoney());
        billSubsidyModify.setBeforeEartagNo(billSubsidy.getEartagNo());
        billSubsidyModify.setBeforeRewardNum(billSubsidy.getRewardNum());
        billSubsidyModify.setAfterApplyMoney(new BigDecimal(afterApplyMoney));
        billSubsidyModify.setAfterEartagNo(afterEartagNo);
        billSubsidyModify.setAfterRewardNum(Integer.parseInt(afterRewardNum));
        billSubsidyModifyMapper.insert(billSubsidyModify);

        billSubsidy.setRewardNum(Integer.parseInt(afterRewardNum));
        billSubsidy.setEartagNo(afterEartagNo);
        billSubsidy.setApplyMoney(new BigDecimal(afterApplyMoney));
        subsidyMapper.updateById(billSubsidy);
        return Result.SUCCESS();
    }

    @Override
    public Result payList(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String code = paramsMap.get("code");//所选乡镇的编码
        String name = paramsMap.get("name");

        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();
        subsidyQueryWrapper.like(StringUtils.isNotBlank(code), "detailed_adress_code", code).like(StringUtils.isNotBlank(name),"farmer_name", name)
                .eq("subsidy_sch", 3).eq("is_pay", 1)
                .eq("is_batch", 0)
                .groupBy("id_card");
        List<BillSubsidy> subsidyList = subsidyMapper.selectList(subsidyQueryWrapper);
        JSONArray jsonArray = new JSONArray();
        for (BillSubsidy billSubsidy : subsidyList) {
            BillSubsidyDto subsidyDto = new BillSubsidyDto();
            BeanUtil.copyProperties(billSubsidy,subsidyDto);
            String detailedAdressCode = billSubsidy.getDetailedAdressCode();
            String[] split = detailedAdressCode.split(",");
            QueryWrapper<AreaAll> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id",  split[2]);
            AreaAll areaAll = areaAllMapper.selectOne(queryWrapper);
            subsidyDto.setCountry(areaAll.getName());
            jsonArray.add(subsidyDto);
        }
        return new Result(ResultCode.SUCCESS, jsonArray);
    }


}
