package com.huimv.farm.test;

import com.huimv.farm.damsubsidy.entity.BillSubsidy;
import com.huimv.farm.damsubsidy.entity.vo.*;
import org.jxls.common.Context;
import org.jxls.util.JxlsHelper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

public class Print3 {
    /**
     * 打印方法  不插入图片
     * @throws Exception
     * @return
     */
    public  static void print(List<BillSubsidy> subsidies, String address, String date) throws Exception {
        //准备数据
        String path ="/opt/subsidy/pay.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        //如果为系统路径 为： InputStream is = new FileInputStream("F://student.xlsx");
        InputStream is = new FileInputStream("/opt/subsidy/pay.xlsx");

        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        List<BillSubsidyPayVo> list = new ArrayList<>();
        Context context = new Context();
        BigDecimal money = BigDecimal.valueOf(0);//奖补奖金
        Integer number = 0;//新引进数量
        Integer i = 1;
        for (BillSubsidy subsidy : subsidies) {
            BillSubsidyPayVo payVo = new BillSubsidyPayVo();
            payVo.setId(i);
            payVo.setCountry(subsidy.getBriefAddress());
            payVo.setUserName(subsidy.getFarmerName());
            payVo.setIdCard(subsidy.getIdCard());
            payVo.setBankName(subsidy.getBankName());
            payVo.setBankCard(subsidy.getBankCardId());
            payVo.setFarmType(subsidy.getFarmerType());
            payVo.setNumber(subsidy.getRewardNum());
            payVo.setMoney(subsidy.getApplyMoney());
            payVo.setPhone(subsidy.getPhone());
            payVo.setSaleName(subsidy.getSaleName());
            number = number + subsidy.getRewardNum();
            money = money.add(subsidy.getApplyMoney());
            list.add(payVo);
            i = i + 1;
        }
        context.putVar("list", list);
        context.putVar("numCount", number);
        context.putVar("moneyCount", money);
        context.putVar("address",address);


        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
//        String path = String.valueOf(os);

    }

    public  static void print2(List<BillSubsidyDto> subsidies, String address, String date) throws Exception {
        //准备数据
        String path ="/opt/subsidy/new_pay.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        //如果为系统路径 为： InputStream is = new FileInputStream("F://student.xlsx");
        InputStream is = new FileInputStream("/opt/subsidy/new_pay.xlsx");

        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        List<BillSubsidyBatchPay> list = new ArrayList<>();
        Context context = new Context();
        BigDecimal money = BigDecimal.valueOf(0);//奖补奖金
        Integer number = 0;//新引进数量
        Integer i = 1;
        for (BillSubsidyDto subsidy : subsidies) {
            BillSubsidyBatchPay payVo = new BillSubsidyBatchPay();
            payVo.setId(i);
            payVo.setAddress(subsidy.getCountry());
            payVo.setSaleName(subsidy.getSellerName());
            payVo.setCountry(subsidy.getBriefAddress());
            payVo.setUserName(subsidy.getFarmerName());
            payVo.setIdCard(subsidy.getIdCard());
            payVo.setBankName(subsidy.getBankName());
            payVo.setBankCard(subsidy.getBankCardId());
            payVo.setFarmType(subsidy.getFarmerType());
            payVo.setNumber(subsidy.getRewardNum());
            if (subsidy.getRewardNum() > 10) {
                payVo.setNotes("养殖大户");
            } else {
                payVo.setNotes("家庭牧场");
            }
            payVo.setMoney(subsidy.getApplyMoney());
            payVo.setPhone(subsidy.getPhone());
            number = number + subsidy.getRewardNum();
            money = money.add(subsidy.getApplyMoney());
            list.add(payVo);
            i = i + 1;
        }
        context.putVar("list", list);
        context.putVar("numCount", number);
        context.putVar("moneyCount", money);
        context.putVar("word", address);
        String[] split = date.split("-");
        String s = split[2];
        String[] strings = s.split(" ");
        context.putVar("date1", split[0]);
        context.putVar("date2", split[1]);
        context.putVar("date3", strings[0]);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
//        String path = String.valueOf(os);

    }

    public  static void print3(List<BillSubsidyTotalVo> subsidies, String address, String date) throws Exception {
        //准备数据
        String path ="/opt/subsidy/new_xian.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        //如果为系统路径 为： InputStream is = new FileInputStream("F://student.xlsx");
        InputStream is = new FileInputStream("/opt/subsidy/new_xian.xlsx");

        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        List<BillSubsidyBatchCount> list = new ArrayList<>();
        Context context = new Context();

        Integer huNum = 0;//奖补户数
        BigDecimal money = BigDecimal.valueOf(0);//奖补奖金
        Integer number = 0;//新引进数量

        Integer huNum1 = 0;//奖补户数
        BigDecimal money1 = BigDecimal.valueOf(0);//奖补奖金
        Integer number1 = 0;//新引进数量

        Integer huNum2 = 0;//奖补户数
        BigDecimal money2 = BigDecimal.valueOf(0);//奖补奖金
        Integer number2 = 0;//新引进数量

        Integer huNum3 = 0;//奖补户数
        BigDecimal money3 = BigDecimal.valueOf(0);//奖补奖金
        Integer number3 = 0;//新引进数量

        Integer huNum4 = 0;//奖补户数
        BigDecimal money4 = BigDecimal.valueOf(0);//奖补奖金
        Integer number4 = 0;//新引进数量

        Integer huNum5 = 0;//奖补户数
        BigDecimal money5 = BigDecimal.valueOf(0);//奖补奖金
        Integer number5 = 0;//新引进数量

        Integer i = 1;
        for (BillSubsidyTotalVo subsidy : subsidies) {
            BillSubsidyBatchCount payVo = new BillSubsidyBatchCount();
            payVo.setId(i);
            payVo.setName(subsidy.getTownName());

            payVo.setHouseHolds(subsidy.getSubsidyFarmerNum().toString());
            payVo.setCattleNum(subsidy.getSubsidyCattleNum());
            payVo.setMoney(subsidy.getSubsidyTotalMoney());

            payVo.setHouseHolds1(subsidy.getGetRidOfPovertyNum().toString());
            payVo.setCattleNum1(subsidy.getGetRidOfPovertyCattleNum());
            payVo.setMoney1(subsidy.getGetRidOfPovertyMoney());

            payVo.setHouseHolds2(subsidy.getMonitorNum().toString());
            payVo.setCattleNum2(subsidy.getMonitorCattleNum());
            payVo.setMoney2(subsidy.getMonitorMoney());

            payVo.setHouseHolds3(subsidy.getOtherNum().toString());
            payVo.setCattleNum3(subsidy.getOtherCattleNum());
            payVo.setMoney3(subsidy.getOtherMoney());

            payVo.setHouseHolds4(subsidy.getBigNum().toString());
            payVo.setCattleNum4(subsidy.getBigCattleNum());
            payVo.setMoney4(subsidy.getBigMoney());

            payVo.setHouseHolds5(subsidy.getEnterpriseNum().toString());
            payVo.setCattleNum5(subsidy.getEnterpriseCattleNum());
            payVo.setMoney5(subsidy.getEnterpriseMoney());

            number = number + subsidy.getSubsidyCattleNum();
            huNum = huNum + subsidy.getSubsidyFarmerNum();
            money = money.add(subsidy.getSubsidyTotalMoney());

            number1 = number1 + subsidy.getGetRidOfPovertyCattleNum();
            huNum1 = huNum1 + subsidy.getGetRidOfPovertyNum();
            money1 = money1.add(subsidy.getGetRidOfPovertyMoney());

            number2 = number2 + subsidy.getMonitorCattleNum();
            huNum2 = huNum2 + subsidy.getMonitorNum();
            money2 = money2.add(subsidy.getMonitorMoney());

            number3 = number3 +subsidy.getOtherCattleNum();
            huNum3 = huNum3 + subsidy.getOtherNum();
            money3 = money3.add(subsidy.getOtherMoney());

            number4 = number4 + subsidy.getBigCattleNum();
            huNum4 = huNum4 + subsidy.getBigNum();
            money4 = money4.add(subsidy.getBigMoney());

            number5 = number5 + subsidy.getEnterpriseCattleNum();
            huNum5 = huNum5 + subsidy.getEnterpriseNum();
            money5 = money5.add(subsidy.getEnterpriseMoney());


            list.add(payVo);
            i = i + 1;
        }
        context.putVar("list", list);
        context.putVar("word", address);

        String[] split = date.split("-");
        String s = split[2];
        String[] strings = s.split(" ");
        context.putVar("date1", split[0]);
        context.putVar("date2", split[1]);
        context.putVar("date3", strings[0]);
        context.putVar("numCount1",huNum);
        context.putVar("numCount2",number);
        context.putVar("numCount3",money);
        context.putVar("numCount4",huNum1);
        context.putVar("numCount5",number1);
        context.putVar("numCount6",money1);
        context.putVar("numCount7",huNum2);
        context.putVar("numCount8",number2);
        context.putVar("numCount9",money2);
        context.putVar("numCount10",huNum2);
        context.putVar("numCount11",number3);
        context.putVar("numCount12",money3);
        context.putVar("numCount13",huNum3);
        context.putVar("numCount14",number4);
        context.putVar("numCount15",money4);
        context.putVar("numCount16",huNum5);
        context.putVar("numCount17",number5);
        context.putVar("numCount18",money5);

        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
//        String path = String.valueOf(os);

    }

    public  static void print4(List<BillSubsidyEnterpriseVo> subsidies, String address, String date) throws Exception {
        //准备数据
        String path ="/opt/subsidy/new_detail.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        //如果为系统路径 为： InputStream is = new FileInputStream("F://student.xlsx");
        InputStream is = new FileInputStream("/opt/subsidy/new_detail.xlsx");

        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        List<BillSubsidyBatchDetail> list = new ArrayList<>();
        Context context = new Context();
        BigDecimal money = BigDecimal.valueOf(0);//奖补奖金
        Integer number = 0;//新引进数量
        Integer i = 1;
        for (BillSubsidyEnterpriseVo subsidy : subsidies) {
            BillSubsidyBatchDetail payVo = new BillSubsidyBatchDetail();
            payVo.setId(i);
            payVo.setAddress(subsidy.getTown());
            payVo.setCountry(subsidy.getBriefAddress());
            payVo.setCompanyName(subsidy.getUserName());
            payVo.setName(subsidy.getCompanyName());
            payVo.setIdCard(subsidy.getIdCard());
            payVo.setNumber(subsidy.getRewardNum());
            payVo.setMoney(subsidy.getApplyMoney());
            payVo.setBank(subsidy.getBankName());
            payVo.setBankName(subsidy.getBankName());
            payVo.setBankCard(subsidy.getBankCardId());
            payVo.setNotes("");

            number = number + subsidy.getRewardNum();
            money = money.add(subsidy.getApplyMoney());
            list.add(payVo);
            i = i + 1;
        }
        context.putVar("list", list);
        context.putVar("numCount", number);
        context.putVar("moneyCount", money);
        context.putVar("word", address);
        String[] split = date.split("-");
        String s = split[2];
        String[] strings = s.split(" ");
        context.putVar("date1", split[0]);
        context.putVar("date2", split[1]);
        context.putVar("date3", strings[0]);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
//        String path = String.valueOf(os);

    }

}